# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_planning_knowledge_msgs/UpdateObjectServiceRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import squirrel_object_perception_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class UpdateObjectServiceRequest(genpy.Message):
  _md5sum = "30ccbc0e37263ca5da70073b3e78e066"
  _type = "squirrel_planning_knowledge_msgs/UpdateObjectServiceRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
squirrel_object_perception_msgs/SceneObject object

================================================================================
MSG: squirrel_object_perception_msgs/SceneObject
# Scene Object
#
# An object with all its attributes as stored in the scene database.
#
# author: Michael Zillich, michael.zillich@tuwien.ac.at

# when the object was last seen
std_msgs/Header header

# a unique meaningless ID, e.g. 'object376', not to be confused with any
# meaningful label, object name etc.
string id

# the object's category, which can be:
# - narrow ('lego-police-truck'), i.e. typically an instance label as
#   returned by a recogniser
# - broad ('truck'), i.e. typically a class label as returned by a classifier
# - unknown, i.e. just 'stuff' where we don't know what is is
string category

# the object's pose, typically given in the map frame
geometry_msgs/Pose pose

# the object's point cloud as segmented from the scene
sensor_msgs/PointCloud2 cloud

# A bounding cylinder, aligned with upwards pointing z-axis and resting on the
# floor. It's center is (pose.x, pose.y, 0)
squirrel_object_perception_msgs/BCylinder bounding_cylinder

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: squirrel_object_perception_msgs/BCylinder
# A bounding cylinder
#
# This is intended for 'stuff' lying on a supporting surface. The cylinder is
# thus axis-aligned with the upwards pointing z-axis, resting on the ground and
# 'height' is the height above the supporting surface.
#
# author: Michael Zillich, michael.zillich@tuwien.ac.at

float32 diameter
float32 height
"""
  __slots__ = ['object']
  _slot_types = ['squirrel_object_perception_msgs/SceneObject']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       object

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UpdateObjectServiceRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.object is None:
        self.object = squirrel_object_perception_msgs.msg.SceneObject()
    else:
      self.object = squirrel_object_perception_msgs.msg.SceneObject()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object.category
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.object.pose.position.x, _x.object.pose.position.y, _x.object.pose.position.z, _x.object.pose.orientation.x, _x.object.pose.orientation.y, _x.object.pose.orientation.z, _x.object.pose.orientation.w, _x.object.cloud.header.seq, _x.object.cloud.header.stamp.secs, _x.object.cloud.header.stamp.nsecs))
      _x = self.object.cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.object.cloud.height, _x.object.cloud.width))
      length = len(self.object.cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.object.cloud.is_bigendian, _x.object.cloud.point_step, _x.object.cloud.row_step))
      _x = self.object.cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B2f.pack(_x.object.cloud.is_dense, _x.object.bounding_cylinder.diameter, _x.object.bounding_cylinder.height))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.object is None:
        self.object = squirrel_object_perception_msgs.msg.SceneObject()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.id = str[start:end].decode('utf-8')
      else:
        self.object.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.category = str[start:end].decode('utf-8')
      else:
        self.object.category = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.object.pose.position.x, _x.object.pose.position.y, _x.object.pose.position.z, _x.object.pose.orientation.x, _x.object.pose.orientation.y, _x.object.pose.orientation.z, _x.object.pose.orientation.w, _x.object.cloud.header.seq, _x.object.cloud.header.stamp.secs, _x.object.cloud.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.object.cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.object.cloud.height, _x.object.cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.object.cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.object.cloud.is_bigendian, _x.object.cloud.point_step, _x.object.cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.object.cloud.is_bigendian = bool(self.object.cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.cloud.data = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.object.cloud.is_dense, _x.object.bounding_cylinder.diameter, _x.object.bounding_cylinder.height,) = _struct_B2f.unpack(str[start:end])
      self.object.cloud.is_dense = bool(self.object.cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object.category
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.object.pose.position.x, _x.object.pose.position.y, _x.object.pose.position.z, _x.object.pose.orientation.x, _x.object.pose.orientation.y, _x.object.pose.orientation.z, _x.object.pose.orientation.w, _x.object.cloud.header.seq, _x.object.cloud.header.stamp.secs, _x.object.cloud.header.stamp.nsecs))
      _x = self.object.cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.object.cloud.height, _x.object.cloud.width))
      length = len(self.object.cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.object.cloud.is_bigendian, _x.object.cloud.point_step, _x.object.cloud.row_step))
      _x = self.object.cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B2f.pack(_x.object.cloud.is_dense, _x.object.bounding_cylinder.diameter, _x.object.bounding_cylinder.height))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.object is None:
        self.object = squirrel_object_perception_msgs.msg.SceneObject()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.id = str[start:end].decode('utf-8')
      else:
        self.object.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.category = str[start:end].decode('utf-8')
      else:
        self.object.category = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.object.pose.position.x, _x.object.pose.position.y, _x.object.pose.position.z, _x.object.pose.orientation.x, _x.object.pose.orientation.y, _x.object.pose.orientation.z, _x.object.pose.orientation.w, _x.object.cloud.header.seq, _x.object.cloud.header.stamp.secs, _x.object.cloud.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object.cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.object.cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.object.cloud.height, _x.object.cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.object.cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.object.cloud.is_bigendian, _x.object.cloud.point_step, _x.object.cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.object.cloud.is_bigendian = bool(self.object.cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.cloud.data = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.object.cloud.is_dense, _x.object.bounding_cylinder.diameter, _x.object.bounding_cylinder.height,) = _struct_B2f.unpack(str[start:end])
      self.object.cloud.is_dense = bool(self.object.cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_IBI = struct.Struct("<IBI")
_struct_2I = struct.Struct("<2I")
_struct_3I = struct.Struct("<3I")
_struct_B2I = struct.Struct("<B2I")
_struct_B2f = struct.Struct("<B2f")
_struct_7d3I = struct.Struct("<7d3I")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_planning_knowledge_msgs/UpdateObjectServiceResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class UpdateObjectServiceResponse(genpy.Message):
  _md5sum = "7c4d579c72a706892830716dca81b7d4"
  _type = "squirrel_planning_knowledge_msgs/UpdateObjectServiceResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint8 SUCCESS = 0
uint8 FAILURE = 1
uint8 result

"""
  # Pseudo-constants
  SUCCESS = 0
  FAILURE = 1

  __slots__ = ['result']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UpdateObjectServiceResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.result is None:
        self.result = 0
    else:
      self.result = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_B.pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.result,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_B.pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.result,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
class UpdateObjectService(object):
  _type          = 'squirrel_planning_knowledge_msgs/UpdateObjectService'
  _md5sum = 'bbd33018d3f811caae8462c26569e660'
  _request_class  = UpdateObjectServiceRequest
  _response_class = UpdateObjectServiceResponse
